
/* test program to demonstrate use of interrupts */
/* Jiri Gaisler, Gaisler Research, 2001          */

extern void *catch_interrupt(void func(), int irq);
int *lreg = (int *) 0x80000000;

enable_irq (int irq) 
{

	lreg[0x9c/4] = (1 << irq);	// clear any pending irq
	lreg[0x90/4] |= (1 << irq);	// unmaks irq
}

disable_irq (int irq) { lreg[0x90/4] &= ~(1 << irq); }	// mask irq

force_irq (int irq) { lreg[0x98/4] = (1 << irq); }	// force irq

/* NOTE: NEVER put printf() or other stdio routines in interrupt handlers,
   they are not re-entrant. This (bad) example is just a demo */

void irqhandler(int irq)
{
	printf("this is irq %d\n", irq);
}


main()
{
	catch_interrupt(irqhandler, 10);
	catch_interrupt(irqhandler, 11);
	catch_interrupt(irqhandler, 12);
	enable_irq(10);
	enable_irq(11);
	enable_irq(12);
	force_irq(10);
	force_irq(10);
	force_irq(10);
	force_irq(10);
	lreg[0x98/4] = (7 << 10); // force irq 10, 11 & 12 simultaneously
	
}



