/*

    LEON2/3 LIBIO low-level routines 
    Written by Jiri Gaisler.
    Copyright (C) 2004  Gaisler Research AB

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <sys/stat.h>

#define DREADY 1
#define TREADY 4

extern volatile int *console;

int
read (fd, buf, nbyte)
     int fd;
     void *buf;
     size_t nbyte;
{
    int data, stat;
    int nsave;

    if (!console) return(-1);
    nsave = nbyte;
    while (nbyte > 0)
      {
	  while (!(console[1] & DREADY));
	  *(char*)buf = (char) console[0];
	  buf++;
	  nbyte--;
      }
    console[1] = 0;
    return (nsave);
}

